using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Text.RegularExpressions;

namespace RfidMultiForm
{

	/// <summary>
	/// o^ItemǗEҏWForm
	/// </summary>
	
	public class ItemForm : System.Windows.Forms.Form
	{

		#region tH[֘AR|[lg̐錾
		private System.Windows.Forms.TextBox textBoxId;
		private System.Windows.Forms.Label labelId;
		private System.Windows.Forms.Label labelTitle;
		private System.Windows.Forms.Label labelName;
		private System.Windows.Forms.TextBox textBoxName;
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.Label labelProgram;
		private System.Windows.Forms.TextBox textBoxProgram;
		private System.Windows.Forms.TextBox textBoxOption;
		private System.Windows.Forms.Button buttonFileDialog1;
		private System.Windows.Forms.Button buttonFileDialog2;
		private System.Windows.Forms.Label labelOption;
		private System.ComponentModel.Container components = null;
		#endregion

		public Item item;
		private const char Separator = '\t';
		private string lastDirectory ="";

		//RXgN^
		public ItemForm(Item item)
		{
			InitializeComponent();
			
			this.item = item;
			textBoxId.Text = item.id.ToString();//item.id.ToString();
			textBoxName.Text = item.name;
			textBoxProgram.Text = item.program;
			
			foreach(string option in item.options)
			{
				textBoxOption.Text = textBoxOption.Text +  Separator + option;
			}
			//擪̃^u폜
			textBoxOption.Text = Regex.Replace(textBoxOption.Text, @"^\t","");
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		//ύXKpC_CAOID
		private void buttonOK_Click(object sender, System.EventArgs e)
		{
			item.name = textBoxName.Text;
			item.program = textBoxProgram.Text;
			item.options = textBoxOption.Text.Split(Separator);
			
			return;
		}

		//Programpt@C_CAOJD
		private void buttonFileDialog1_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog openDialog = new OpenFileDialog();
			openDialog.InitialDirectory = Application.StartupPath;
			openDialog.Filter = "exe files (*.exe)|*.exe|all files (*.*)|*.*" ;
			openDialog.FilterIndex = 1 ;
			openDialog.RestoreDirectory = true;
			openDialog.Multiselect = false;
			if(lastDirectory!=""){
				openDialog.InitialDirectory = lastDirectory;
			}

			if(openDialog.ShowDialog() == DialogResult.OK)
			{
				this.textBoxProgram.Text = openDialog.FileName;

				Match m = Regex.Match(openDialog.FileName, @"(.*)\\(.*)$");
				if(m.Success)
				{
					lastDirectory = m.Groups[0].Value;
				}
			}
			//DialogResult.OK̂܂܏IƁC̃_CAOƏIĂ܂D
			DialogResult = DialogResult.None;
		}

		private void buttonFileDialog2_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog openDialog = new OpenFileDialog();
			openDialog.InitialDirectory = Application.StartupPath;
			openDialog.Filter = "all files (*.*)|*.*" ;
			openDialog.FilterIndex = 1 ;
			openDialog.RestoreDirectory = true ;
			openDialog.Multiselect = true;

			if(lastDirectory!="")
			{
				openDialog.InitialDirectory = lastDirectory;
			}

			if(openDialog.ShowDialog() == DialogResult.OK)
			{
				foreach(string filename in openDialog.FileNames)
				{
					textBoxOption.Text = filename + "\t" + textBoxOption.Text;
				}
				Match m = Regex.Match(openDialog.FileName, @"(.*)\\(.*)$");
				if(m.Success)
				{
					lastDirectory = m.Groups[0].Value;
				}
			}
			//DialogResult.OK̂܂܏IƁC̃_CAOƏIĂ܂D
			DialogResult = DialogResult.None;
		}

		
		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.textBoxId = new System.Windows.Forms.TextBox();
			this.labelId = new System.Windows.Forms.Label();
			this.labelTitle = new System.Windows.Forms.Label();
			this.labelName = new System.Windows.Forms.Label();
			this.textBoxName = new System.Windows.Forms.TextBox();
			this.labelProgram = new System.Windows.Forms.Label();
			this.textBoxProgram = new System.Windows.Forms.TextBox();
			this.buttonOK = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.textBoxOption = new System.Windows.Forms.TextBox();
			this.labelOption = new System.Windows.Forms.Label();
			this.buttonFileDialog1 = new System.Windows.Forms.Button();
			this.buttonFileDialog2 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// textBoxId
			// 
			this.textBoxId.Location = new System.Drawing.Point(72, 32);
			this.textBoxId.Name = "textBoxId";
			this.textBoxId.ReadOnly = true;
			this.textBoxId.Size = new System.Drawing.Size(160, 19);
			this.textBoxId.TabIndex = 0;
			this.textBoxId.Text = "";
			// 
			// labelId
			// 
			this.labelId.Location = new System.Drawing.Point(16, 32);
			this.labelId.Name = "labelId";
			this.labelId.Size = new System.Drawing.Size(24, 23);
			this.labelId.TabIndex = 1;
			this.labelId.Text = "ID:";
			// 
			// labelTitle
			// 
			this.labelTitle.Location = new System.Drawing.Point(8, 8);
			this.labelTitle.Name = "labelTitle";
			this.labelTitle.Size = new System.Drawing.Size(216, 16);
			this.labelTitle.TabIndex = 2;
			this.labelTitle.Text = "IDɑΉL[[hȂǂo^܂";
			// 
			// labelName
			// 
			this.labelName.Location = new System.Drawing.Point(16, 72);
			this.labelName.Name = "labelName";
			this.labelName.Size = new System.Drawing.Size(48, 16);
			this.labelName.TabIndex = 3;
			this.labelName.Text = "Name:";
			// 
			// textBoxName
			// 
			this.textBoxName.Location = new System.Drawing.Point(72, 72);
			this.textBoxName.Name = "textBoxName";
			this.textBoxName.Size = new System.Drawing.Size(160, 19);
			this.textBoxName.TabIndex = 4;
			this.textBoxName.Text = "";
			// 
			// labelProgram
			// 
			this.labelProgram.Location = new System.Drawing.Point(8, 112);
			this.labelProgram.Name = "labelProgram";
			this.labelProgram.Size = new System.Drawing.Size(56, 16);
			this.labelProgram.TabIndex = 5;
			this.labelProgram.Text = "Program:";
			// 
			// textBoxProgram
			// 
			this.textBoxProgram.Location = new System.Drawing.Point(72, 112);
			this.textBoxProgram.Name = "textBoxProgram";
			this.textBoxProgram.Size = new System.Drawing.Size(160, 19);
			this.textBoxProgram.TabIndex = 6;
			this.textBoxProgram.Text = "";
			// 
			// buttonOK
			// 
			this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonOK.Location = new System.Drawing.Point(40, 192);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.Size = new System.Drawing.Size(56, 23);
			this.buttonOK.TabIndex = 7;
			this.buttonOK.Text = "o^";
			this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
			// 
			// buttonCancel
			// 
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonCancel.Location = new System.Drawing.Point(136, 192);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 8;
			this.buttonCancel.Text = "LZ";
			// 
			// textBoxOption
			// 
			this.textBoxOption.Location = new System.Drawing.Point(72, 152);
			this.textBoxOption.Name = "textBoxOption";
			this.textBoxOption.Size = new System.Drawing.Size(160, 19);
			this.textBoxOption.TabIndex = 10;
			this.textBoxOption.Text = "";
			// 
			// labelOption
			// 
			this.labelOption.Location = new System.Drawing.Point(16, 152);
			this.labelOption.Name = "labelOption";
			this.labelOption.Size = new System.Drawing.Size(48, 16);
			this.labelOption.TabIndex = 9;
			this.labelOption.Text = "Option:";
			// 
			// buttonFileDialog1
			// 
			this.buttonFileDialog1.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonFileDialog1.Location = new System.Drawing.Point(248, 112);
			this.buttonFileDialog1.Name = "buttonFileDialog1";
			this.buttonFileDialog1.Size = new System.Drawing.Size(56, 23);
			this.buttonFileDialog1.TabIndex = 11;
			this.buttonFileDialog1.Text = "Q";
			this.buttonFileDialog1.Click += new System.EventHandler(this.buttonFileDialog1_Click);
			// 
			// buttonFileDialog2
			// 
			this.buttonFileDialog2.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonFileDialog2.Location = new System.Drawing.Point(248, 152);
			this.buttonFileDialog2.Name = "buttonFileDialog2";
			this.buttonFileDialog2.Size = new System.Drawing.Size(56, 23);
			this.buttonFileDialog2.TabIndex = 12;
			this.buttonFileDialog2.Text = "Q";
			this.buttonFileDialog2.Click += new System.EventHandler(this.buttonFileDialog2_Click);
			// 
			// ItemForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(312, 222);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.buttonFileDialog2,
																		  this.buttonFileDialog1,
																		  this.textBoxOption,
																		  this.labelOption,
																		  this.buttonCancel,
																		  this.buttonOK,
																		  this.textBoxProgram,
																		  this.labelProgram,
																		  this.textBoxName,
																		  this.labelName,
																		  this.labelTitle,
																		  this.labelId,
																		  this.textBoxId});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "ItemForm";
			this.Text = "ItemForm";
			this.ResumeLayout(false);

		}
		#endregion

	}
}
