using System;
using System.Collections;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace RfidMultiForm
{	

	public struct RfidData
	{
		public byte status;
		public byte dsfId;
		public ulong id;
	}

	public enum IdTx{Inventory, Read, ReadDetail, ReadSpecial, Write, Lock};

	//RFID[_[pNX(ǎŁj
	public class RFIDComm
	{

		//RFID[_[ɑM\
		private struct RfidPacketTx	//Max Length = ??
		{	
			public byte sof;	
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=2)] 
			public byte []length; 
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=2)] 
			public byte []nodeAddress;
			public byte commandFlag;
			public byte command;
			[MarshalAs(UnmanagedType.ByValArray)]			//0-xxbyte
			public byte [] data;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=2)] 
			public byte [] bcc;
		}

		//RFID[_[M\
		//private struct RfidPacketRx
		//{
		//	public byte sof;
		//	[MarshalAs(UnmanagedType.ByValArray, SizeConst=2)] 
		//	public byte []length; 
		//	[MarshalAs(UnmanagedType.ByValArray, SizeConst=2)] 
		//	public byte []nodeAddress;
		//	public byte commandFlag;
		//	public byte command;
		//	[MarshalAs(UnmanagedType.ByValArray)]			//0--23byte
		//	public byte [] data;
		//	[MarshalAs(UnmanagedType.ByValArray, SizeConst=2)] 
		//	public byte [] bcc;
		//}

		const byte COMMAND_FLAG_REQUEST_SELECTED = 0x10;	//00010000
		const byte COMMAND_FLAG_REQUEST_ALL = 0x00;		//00000000
		const byte COMMAND_FLAG_RESPONSE_ERROR   = 0x10;	
		const byte COMMAND_FLAG_RESPONSE_OK = 0x00;	

		//ʐMp̃X^[goCg
		const byte SOH = 0x01;

		//RFIDւ̖߂\萔
		//const byte READ_SINGLE =  0x02; 
		//const byte WRITE_SINGLE = 0x03; 
		//const byte LOCK_SINGLE =  0x04;	
		//const byte READ_SPECIAL = 0x0F; 

		const byte READ_DETAILS = 0x05; 
		//ڍ׏ Address[4 byte] Manufacturers code[1 byte], Transponder version nuber[2 byte]
		//		   Number of blocks[1 byte], number of byte per block[1 byte]
		//̃ubN݂̂ǂݍ( B0011001 = 0x18)
		
		
		const byte COMMAND_ISO = 0x60;
		const byte ISO_INVENTORY = 0x01;

		//VA|[gʐMpNX̐錾
		Rs232c comm;

		//RXgN^
		public RFIDComm(string port, int baudRate)
		{		
			comm = new Rs232c(port, baudRate);
		}

		//VAʐMp|[gԍݒC擾
		public string Port
		{
			set{comm.Port = value;}
			get{return comm.Port;}
		}

		//VAʐM|[gJ
		public bool Open()
		{
			bool flag = comm.Open();
			return flag;
		}

		//VAʐM|[g
		public void Close()
		{
			comm.Close();
			return;
		}

		//VAʐM|[gJĂtrueCĂfalse
		public bool IsOpen
		{
			get{return this.comm.IsOpen;}
		}


		//VA|[gʂāCRFID[_ɃbZ[W𑗐M
		public bool SendMessage(IdTx id, uint address, byte block, byte [] data)
		{
			byte [] txBytes;
			ushort length;
			
			RfidPacketTx packetTx;

			try
			{
				packetTx = new RfidPacketTx();
				packetTx.sof= SOH;
				packetTx.nodeAddress = new byte[] {0x00, 0x00};
				packetTx.bcc = new byte[2];

				switch(id)
				{

					case IdTx.Inventory:
					{

						packetTx.commandFlag = COMMAND_FLAG_REQUEST_ALL;

						packetTx.data = new byte[5];
						packetTx.data[0] = 0;		//Configuration Byte
						packetTx.data[1] = 0x17;	
						packetTx.data[2] = ISO_INVENTORY;
						packetTx.data[3] = 0;
						length = (ushort)(9 + 5);
						packetTx.length = BitConverter.GetBytes(length);
						
						packetTx.command = COMMAND_ISO;
						packetTx.bcc[0] = (byte)(packetTx.sof ^ packetTx.length[0] ^ packetTx.length[1] ^ 
							packetTx.nodeAddress[0] ^ packetTx.nodeAddress[1] ^ 
							packetTx.commandFlag ^ packetTx.command);

						if(packetTx.data != null)
						{
							for(int i =0;i< packetTx.data.Length;i++)
							{
								packetTx.bcc[0] = (byte)(packetTx.bcc[0] ^ packetTx.data[i]);
							}
						}

						packetTx.bcc[1] = (byte)(~packetTx.bcc[0]);
						
						break;
					}
					case IdTx.ReadDetail:
					{
						if(address == 0)
						{
							packetTx.commandFlag = COMMAND_FLAG_REQUEST_ALL;
							packetTx.data = null;
							length = (ushort)(9);
							packetTx.length = BitConverter.GetBytes(length);
						}
						else
						{
							packetTx.commandFlag = COMMAND_FLAG_REQUEST_SELECTED;
							packetTx.data = new byte[4];
							byte [] tmp = BitConverter.GetBytes(address);
							for(int i=0;i<4;i++)
							{
								packetTx.data[i] = tmp[i];
							}
							length = (ushort)(9 + packetTx.data.Length);
							packetTx.length = BitConverter.GetBytes(length);
							//packetTx.data[4] = block;
						}

						packetTx.command = READ_DETAILS;
					

						
						packetTx.bcc[0] = (byte)(packetTx.sof ^ packetTx.length[0] ^ packetTx.length[1] ^ 
							packetTx.nodeAddress[0] ^ packetTx.nodeAddress[1] ^ 
							packetTx.commandFlag ^ packetTx.command);
						if(packetTx.data != null)
						{
							for(int i =0;i< packetTx.data.Length;i++)
							{
								packetTx.bcc[0] = (byte)(packetTx.bcc[0] ^ packetTx.data[i]);
							}
						}

						packetTx.bcc[1] = (byte)(~packetTx.bcc[0]);
						break;
					}

					default:
						return false;
				}
			
				//\̂oCgɕϊ
				txBytes = ConvertToBytes(packetTx);
				//VA|[gɃoCgo
				comm.WriteBytes(txBytes);
			}
			catch(Exception ex)
			{
				return false;
			}

			return true;
		}

		

		//VA|[gʂāCRFID[_烁bZ[WMCID擾
		public bool ReceiveMessage(ref byte [] rxBytes, ref RfidData [] rfidDatas)//, ref RFIDDataRx dataRx
		{
			//̓f[^̔
			//RfidPacketRx packetRx;

			ushort length=0;
			byte commandFlag=0;
			byte command =0;
			byte [] dataBytes = null;
			byte [] tmpBytes = new byte [rxBytes.Length];
			
			//bool endFlag = false;
			ushort rxByteCount = 0;

			if(!comm.IsOpen)
				return false;		

	
			while(true)
			{
				bool flag = comm.ReadBytes(ref tmpBytes);

				if(!flag)
					return false;

				if(tmpBytes.Length < 3) 
					return false;
			
				length = BitConverter.ToUInt16(tmpBytes, 1);
				tmpBytes = ChopBytes(tmpBytes);
			
				//pPbgvȂΌJԂD
				if(length > tmpBytes.Length + rxByteCount)
				{
					
					for(int i=0;i<tmpBytes.Length;i++)
					{
						rxBytes[rxByteCount+i] = tmpBytes[i];
					}
					rxByteCount = (ushort)tmpBytes.Length;
					continue;
				}
				else
				{
					for(int i=0;i<length;i++)
					{
						rxBytes[rxByteCount+i] = tmpBytes[i];
					}
					rxBytes = ChopBytes(rxBytes);
					break;
				}
			}


			if(rxBytes.Length < 6) 
				return false;

			commandFlag = rxBytes[5];


			//X^[grbgŎn܂ĂȂΏI
			if(rxBytes[0] != RFIDComm.SOH)
			{
				return false;
			}

			//G[tOĂΏI
			if(commandFlag == COMMAND_FLAG_RESPONSE_ERROR)
			{
				return false;
			}

			command = rxBytes[6];			

			switch(command)
			{
				case COMMAND_ISO:
				{

					if(rxBytes.Length < 23)
					{
						//No Tags.
						break;
					}

					ushort dataFlag;
					ushort collisionFlag;
					
					dataFlag = BitConverter.ToUInt16(rxBytes,7);				
					collisionFlag = BitConverter.ToUInt16(rxBytes,9);
					
					int idCount = 0;

					idCount = (rxBytes.Length - 13) / 10;

					//byte [] status = new byte[idCount];//Error Status
					//byte [] dsfIds = new byte[idCount];//Data Storage Format ID	
					//ulong [] ids = new ulong[idCount];

					rfidDatas = new RfidData[idCount];

					for(int i=0;i<idCount;i++)
					{
						rfidDatas[i].status = rxBytes[10+(i*10)];
						rfidDatas[i].dsfId =  rxBytes[11+(i*10)];
						rfidDatas[i].id = BitConverter.ToUInt64(rxBytes, 12+(i*10));
						//status[i] = rxBytes[10+(i*10)];
						//dsfIds[i] = rxBytes[11+(i*10)];
						//ids[i] = BitConverter.ToUInt64(rxBytes, 12+(i*10));
					}
			
					
					break;
				}

				case READ_DETAILS:
				{
					dataBytes = new byte [9];
					Array.Copy(rxBytes, 7, dataBytes, 0, 9);
					uint id;
					id = BitConverter.ToUInt32(dataBytes,0);
					byte vId;
					vId = dataBytes[4];
					ushort version;
					version = BitConverter.ToUInt16(dataBytes,5);
					ushort blockNum;
					blockNum = dataBytes[7];
					ushort blockByteNum;
					blockByteNum = dataBytes[8];
					break;
				}

				default:
				{
					return false;
				}
			}
			return true;
		}

		//oCgz̍ŌNUL؂藎ƂD
		private byte [] ChopBytes(byte [] bytes)
		{
			int cnt=0;

				while(true)
				{
					if(bytes[bytes.Length - (1+cnt)] != 0x00)
					{
						break;
					}
					cnt++;
					if(cnt >= bytes.Length)
						break;
				}

				byte [] newBytes = new byte[bytes.Length - (cnt)];

				for(int i=0; i<newBytes.Length;i++)
				{
					newBytes[i] = bytes[i];
				}

				return newBytes;

		}
		
		//RFIDCommandTx^\̂oCgɕϊ
		private byte [] ConvertToBytes(RfidPacketTx tx)
		{
			int length =BitConverter.ToUInt16(tx.length,0);
			byte [] txBytes = new byte[length];//3 + 
			txBytes[0] = tx.sof;
			txBytes[1] = tx.length[0];
			txBytes[2] = tx.length[1];
			txBytes[3] = tx.nodeAddress[0];
			txBytes[4] = tx.nodeAddress[1];
			txBytes[5] = tx.commandFlag;
			txBytes[6] = tx.command;
			
			if(tx.data != null)
			{
				for(int i=0;i<tx.data.Length;i++)
				{
					txBytes[i+7] = tx.data[i];
				}
			}
			
			txBytes[length-2] = tx.bcc[0];
			txBytes[length-1] = tx.bcc[1];
			
			return txBytes;
		}
		
	}
}
